/*
 * com.c
 *
 *  Created on: 24. 4. 2017
 *      Author: Martin
 */

#include <stm32l0xx_hal.h>
#include <com.h>

#define MAX_MESSAGE_SIZE 120

extern UART_HandleTypeDef huart2;
extern void string_received_callback(char *message);

char message[MAX_MESSAGE_SIZE];
char received;

void com_init()
{
    HAL_UART_Receive_IT(&huart2, (uint8_t *)&received, 1);
}

void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
    static int n = 0;

    message[n++] = received;

    if((received == '\r') || (received == '\n') || (received == '\0'))
    {
        n = 0;
        string_received_callback(message);
    }

    if (n >= MAX_MESSAGE_SIZE)
    {
        n = 0;
    }

    HAL_UART_Receive_IT(&huart2, (uint8_t *)&received, 1);
}
