/*
 * disp.c
 *
 *  Created on: 25. 4. 2017
 *      Author: Martin
 */

#include <stm32l0xx_hal.h>
#include <disp.h>

#define GPIO_E GPIOA
#define GPIO_PIN_E GPIO_PIN_7

#define GPIO_RS GPIOA
#define GPIO_PIN_RS GPIO_PIN_6

#define GPIO_D4 GPIOA
#define GPIO_PIN_D4 GPIO_PIN_8

#define GPIO_D5 GPIOB
#define GPIO_PIN_D5 GPIO_PIN_7

#define GPIO_D6 GPIOB
#define GPIO_PIN_D6 GPIO_PIN_6

#define GPIO_D7 GPIOB
#define GPIO_PIN_D7 GPIO_PIN_5

void _send_nibble(char nibble);
void _send_cmd(char byte);
void _send_data(char byte);

void disp_init()
{
    HAL_Delay(5);

    _send_nibble(0x30);
    HAL_Delay(5);

    _send_nibble(0x30);
    HAL_Delay(5);

    _send_cmd(0x32);

    _send_cmd(0x28);

    _send_cmd(0x0e);

    _send_cmd(0x06);

    _send_cmd(0x01);
}

void disp_update(disp_t *disp)
{
    disp_update_line0(disp);
    disp_update_line1(disp);
}

void disp_update_line0(disp_t *disp)
{
    _send_cmd(0x80);
    for (int i = 0; i < 16; i++)
    {
        _send_data(disp->image[0][i]);
    }
}

void disp_update_line1(disp_t *disp)
{
    _send_cmd(0xc0);
    for (int i = 0; i < 16; i++)
    {
        _send_data(disp->image[1][i]);
    }
}

void _send_nibble(char nibble)
{
    HAL_GPIO_WritePin(GPIO_D7, GPIO_PIN_D7, nibble & 0x80);
    HAL_GPIO_WritePin(GPIO_D6, GPIO_PIN_D6, nibble & 0x40);
    HAL_GPIO_WritePin(GPIO_D5, GPIO_PIN_D5, nibble & 0x20);
    HAL_GPIO_WritePin(GPIO_D4, GPIO_PIN_D4, nibble & 0x10);

    for(volatile int i = 0; i < 2000; i++)
    {
        continue;
    }
    HAL_GPIO_WritePin(GPIO_E, GPIO_PIN_E, GPIO_PIN_SET);
    for(volatile int i = 0; i < 2000; i++)
    {
        continue;
    }
    HAL_GPIO_WritePin(GPIO_E, GPIO_PIN_E, GPIO_PIN_RESET);
}

void _send_cmd(char byte)
{
    HAL_GPIO_WritePin(GPIO_RS, GPIO_PIN_RS, GPIO_PIN_RESET);

    _send_nibble(byte & 0xf0);
    _send_nibble((byte << 4) & 0xf0);
}

void _send_data(char byte)
{
    HAL_GPIO_WritePin(GPIO_RS, GPIO_PIN_RS, GPIO_PIN_SET);

    _send_nibble(byte & 0xf0);
    _send_nibble((byte << 4) & 0xf0);
}
