/*
 * temp.c
 *
 *  Created on: 6. 5. 2017
 *      Author: Martin
 */

#include <temp.h>
#include <stdint.h>

#include <stm32l0xx_hal.h>

#define ADDR_IN 0x40
#define ADDR_OUT 0x41

extern I2C_HandleTypeDef hi2c1;

void temp_init()
{
    uint8_t reg = 0x80;

    HAL_I2C_Mem_Write(&hi2c1, ADDR_IN << 1, 0x0e, 1, &reg, 1, 10);

    HAL_I2C_Mem_Write(&hi2c1, ADDR_OUT << 1, 0x0e, 1, &reg, 1, 10);
}

void temp_start()
{
    uint8_t reg = 0x01;

    HAL_I2C_Mem_Write(&hi2c1, ADDR_IN << 1, 0x0f, 1, &reg, 1, 10);

    HAL_I2C_Mem_Write(&hi2c1, ADDR_OUT << 1, 0x0f, 1, &reg, 1, 10);
}

void temp_get(float *temp_in, float *temp_out)
{
    uint16_t reg;

    // Get temperature in
    HAL_I2C_Mem_Read(&hi2c1, ADDR_IN << 1, 0x00, 1, (uint8_t *)&reg, 2, 10);
    *temp_in = (reg / 65536.) * 165. - 40.;

    // Get temperature out
    HAL_I2C_Mem_Read(&hi2c1, ADDR_OUT << 1, 0x00, 1, (uint8_t *)&reg, 2, 10);
    *temp_out = (reg / 65536.) * 165. - 40.;

    temp_start();
}
